devices/urls.py
from django.urls import path
import devices.views

app_name = "devices"

urlpatterns = [
    path("", devices.views.Index.as_view(), name="index"),
    path("accept/<str:device>", devices.views.AcceptDevice.as_view(), name="accept"),
    path("reject/<str:device>", devices.views.RejectDevice.as_view(), name="reject"),
    path("devicelist/", devices.views.DeviceList.as_view(), name="devicelist"),
   #path("devicedetails/", devices.views.DeviceDetails.as_view(), name="devicedetails"),
    path("devicedetails/<int:device_id>/", devices.views.DeviceDetails123.as_view(), name="devicedetails"),
    path('snapshot-device/<str:device>/', devices.views.DeviceSnapshotSave.as_view(), name='snapshot-device'),

    path(
        "<str:device>/network/<str:network>",
        devices.views.NetworkDevice.as_view(),
        name="network",
    ),
]

jobs/urls.py
from django.urls import path
import jobs.views
import jobs.models

app_name = "jobs"

urlpatterns = [
    path("", jobs.views.Index.as_view(), name="index"),
    path("executions/", jobs.views.Executions.as_view(), name="executions"),
    path("executions/id/<int:id>", jobs.views.Executions.as_view(), name="execution"),
    path(
        "executions/job/<str:job_id>",
        jobs.views.Executions.as_view(),
        name="executions_job",
    ),
    path("results/", jobs.views.Results.as_view(), name="results"),
    path(
        "results/id/<int:job_execution_id>", jobs.views.Results.as_view(), name="result"
    ),
    path("results/job/<str:job>", jobs.views.Results.as_view(), name="results_job"),
]

networks/urls.py
from django.urls import path
import networks.views

app_name = "networks"

urlpatterns = [
    path("", networks.views.Index.as_view(), name="index"),
    path("name/<str:name>", networks.views.Index.as_view(), name="network"),
    path(
        "type/<str:network_type>", networks.views.Index.as_view(), name="networks_type"
    ),
]

nsp/urls.py
import api.views
from django.conf import settings
from django.conf.urls.static import static
from django.contrib import admin
from django.urls import include, path, re_path

from drf_yasg import openapi
from drf_yasg.views import get_schema_view

from rest_framework import routers, permissions
from rest_framework.authtoken import views
from django.template.defaulttags import register


@register.filter
def get_item(dictionary, key):
    return dictionary.get(key)


openapi_info = openapi.Info(
    title="NSP",
    default_version="0.1.0",
    description="Network Science Platform",
    contact=openapi.Contact(email="keith.birdsall@aicloud.guru"),
    license=openapi.License(name="MIT License"),
)

schema_view = get_schema_view(
    openapi_info,
    public=True,
    permission_classes=[permissions.AllowAny],
)


class OptionalSlashRouter(routers.DefaultRouter):
    def __init__(self):
        super().__init__()
        self.trailing_slash = "/?"


api_router = OptionalSlashRouter()

api_router.register(r"admin/users", api.views.UserViewSet)
api_router.register(r"admin/groups", api.views.GroupViewSet)

api_router.register(r"tenants", api.views.TenantViewSet)
api_router.register(r"epgs", api.views.EndpointGroupViewSet)
api_router.register(r"jobs", api.views.JobViewSet)
api_router.register(r"executions", api.views.JobExecutionViewSet)
api_router.register(r"results", api.views.JobResultViewSet)
api_router.register(r"devices", api.views.DeviceViewSet)
api_router.register(r"dashboards", api.views.DashboardViewSet)
api_router.register(r"networks", api.views.BaseNetworkViewSet)
api_router.register(r"vrfs", api.views.VrfViewSet)
api_router.register(r"l3vnis", api.views.L3VniViewSet)
api_router.register(r"vlans", api.views.VlanViewSet)
api_router.register(r"interfaces", api.views.InterfaceViewSet)
#api_router.register(r"snapshots", api.views.SnapshotViewSet)

urlpatterns = [
    path("admin/", admin.site.urls),
    path("api-auth/", include("rest_framework.urls", namespace="rest_framework")),
    path("api-token-auth/", views.obtain_auth_token),
    path("api/", include(api_router.urls)),
    # path("api/epgs/", api.views.EndpointGroupList.as_view()),
    # path("api/epgs/<int:id>/", api.views.EndpointGroupDetail.as_view()),
    path("login/", include("login.urls")),
    path("networks/", include("networks.urls")),
    path("jobs/", include("jobs.urls")),
    path("dashboards/", include("dashboards.urls")),
    path("settings/", include("settings.urls")),
    path("devices/", include("devices.urls")),
    re_path(
        r"^api/swagger(?P<format>\.json|\.yaml)$",
        schema_view.without_ui(cache_timeout=0),
        name="schema-json",
    ),
    re_path(
        r"^api/swagger/$",
        schema_view.with_ui("swagger", cache_timeout=0),
        name="schema-swagger-ui",
    ),
    re_path(
        r"^api/redoc/$",
        schema_view.with_ui("redoc", cache_timeout=0),
        name="schema-redoc",
    ),
    path("", include("devices.urls")),
    path("", include("django_prometheus.urls")),
] + static(settings.STATIC_URL, document_root=settings.STATIC_ROOT)

settings/urls.py
from django.urls import path
import settings.views

app_name = "settings"

urlpatterns = [
    path("", settings.views.index, name="index"),
]

templates/base.html
{% load static %}
<!DOCTYPE html>
<html>

<head>
  <meta charset="utf-8" />
  {% block title %}
  <title>NARRS</title>
  {% endblock title %} {% block stylesheet %}
  <link href="https://fonts.googleapis.com/css2?family=Dosis:wght@500&display=swap" rel="stylesheet" />
  <link href="https://cdn.jsdelivr.net/npm/bootstrap@5.2.3/dist/css/bootstrap.min.css" rel="stylesheet" />
  <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/6.4.0/css/all.min.css" />
  <link rel="stylesheet" href="{% static 'home/css/base.css' %}" />
  <link rel="icon" type="image/x-icon" href="{% static 'home/img/favicon.ico' %}">

  {% endblock stylesheet %}
</head>

{% block body %}

<body>
  <div id="wrapper">
    <aside id="sidebar-wrapper">
      <div class="stars">
        <div class="sidebar-brand">
          <h2 style="color: #fff;">NARRS</h2>
        </div>
        <div>
          <ul class="sidebar-nav">
            <div class="accordion-nav" id="accordion-nav">
              <div class="accordion-nav-item">
                <h2 class="accordion-nav-header">
                  <button data-tableid="dashboards" class="nav-breadcrumb accordion-nav-button collapsed" type="button"
                    data-bs-toggle="collapse" data-bs-target="#accordion-dashboards" aria-expanded="false">
                    <a href="{% url 'dashboards:index' %}">
                      <li>
                        <i class="fa fa-table-columns fa-xl" title="Dashboards"></i>Dashboards
                      </li>
                    </a>
                  </button>
                </h2>
                <div data-tableid="dashboards" id="accordion-dashboards"
                  class="nav-breadcrumb accordion-nav-collapse collapse" data-bs-parent="#accordion-nav">
                  <div class="nav-breadcrumb accordion-nav-body">
                  </div>
                </div>
              </div>
              <div class="accordion-nav-item">
                <h2 class="accordion-nav-header">
                  <button data-tableid="devices" class="nav-breadcrumb accordion-nav-button collapsed" type="button"
                    data-bs-toggle="collapse" data-bs-target="#accordion-devices" aria-expanded="false">
                    <a href="{% url 'devices:index' %}">
                      <li>
                        <i class="fa-solid fa-server fa-xl" title="Devices"></i>Devices
                      </li>
                    </a>
                  </button>
                </h2>
                <div data-tableid="devices" id="accordion-devices"
                  class="nav-breadcrumb accordion-nav-collapse collapse" data-bs-parent="#accordion-nav">
                  <div class="nav-breadcrumb accordion-nav-body">
                    <a href="{% url 'devices:devicelist' %}">
                      <li>
                        <i class="fa-solid fa-wrench" title="DeviceDetails"></i>Details
                      </li>
                    </a>
                  </div>
                </div>
              </div>
              <div class="accordion-nav-item">
                <h2 class="accordion-nav-header">
                  <button data-tableid="networks" class="nav-breadcrumb accordion-nav-button collapsed" type="button"
                    data-bs-toggle="collapse" data-bs-target="#accordion-networks" aria-expanded="false">
                    <a href="{% url 'networks:index' %}">
                      <li>
                        <i class="fa-solid fa-diagram-project fa-xl" title="Networks"></i>Networks
                      </li>
                    </a>
                  </button>
                </h2>
                <div data-tableid="networks" id="accordion-networks"
                  class="nav-breadcrumb accordion-nav-collapse collapse" data-bs-parent="#accordion-nav">
                  <div class="nav-breadcrumb accordion-nav-body">
                  </div>
                </div>
              </div>
              <div class="accordion-nav-item">
                <h2 class="accordion-nav-header">
                  <button data-tableid="jobs" class="nav-breadcrumb accordion-nav-button collapsed" type="button"
                    data-bs-toggle="collapse" data-bs-target="#accordion-jobs" aria-expanded="false">
                    <a href="{% url 'jobs:index' %}">
                      <li>
                        <i class="fa-solid fa-gear fa-xl" title="Jobs"></i>Jobs
                      </li>
                    </a>
                  </button>
                </h2>
                <div data-tableid="jobs" id="accordion-jobs" class="nav-breadcrumb accordion-nav-collapse collapse"
                  data-bs-parent="#accordion-nav">
                  <div class="nav-breadcrumb accordion-nav-body" data-tableid="executions">
                    <a href="{% url 'jobs:executions' %}">
                      <li>
                        <i class="fa-solid fa-gears fa-xl" title="Executions"></i>Executions
                      </li>
                    </a>
                  </div>
                  <div class="nav-breadcrumb accordion-nav-body" data-tableid="results">
                    <a href="{% url 'jobs:results' %}">
                      <li>
                        <i class="fa-solid fa-list-check fa-xl" title="Results"></i>Results
                      </li>
                    </a>
                  </div>
                </div>
              </div>
              <div class="accordion-nav-item">
                <h2 class="accordion-nav-header">
                  <button data-tableid="settings" class="nav-breadcrumb accordion-nav-button collapsed" type="button"
                    data-bs-toggle="collapse" data-bs-target="#accordion-settings" aria-expanded="false">
                    <a href="{% url 'settings:index' %}">
                      <li>
                        <i class="fa-solid fa-wrench fa-xl" title="Settings"></i>Settings
                      </li>
                    </a>
                  </button>
                </h2>
                <div data-tableid="settings" id="accordion-settings"
                  class="nav-breadcrumb accordion-nav-collapse collapse" data-bs-parent="#accordion-nav">
                  <div class="nav-breadcrumb accordion-nav-body">
                  </div>
                </div>
              </div>
            </div>
          </ul>
        </div>
        {% block sidebar %} {% endblock sidebar %}

        <div class="container svg-links">
          <div class="row ms-0">
            <div class="col">
              <a href="{% url 'api-root' %}"><img src="{% static 'home/img/django.svg' %}" /></a>
            </div>
            <div class="col">
              <a href="{% url 'schema-swagger-ui' %}"><img src="{% static 'home/img/swagger.svg' %}" /></a>
            </div>
            <div class="col">
              <a href="{% url 'admin:logout' %}"><img src="{% static 'home/img/logout.svg' %}" /></a>
            </div>
          </div>
        </div>
        <div class="glowing_stars">
          <div class="star"></div>
          <div class="star"></div>
          <div class="star"></div>
          <div class="star"></div>
          <div class="star"></div>
        </div>
      </div>
    </aside>

    <div id="navbar-wrapper">
      <nav class="navbar navbar-expand-lg navbar-light bg-light">
        <div class="container-fluid">
          <div class="flex-grow-1 text-right">
            <ul class="navbar-nav ms-auto flex-nowrap flex-grow-1">
              <li class="nav-item flex-grow-1">
                <div class="d-flex justify-content-start">
                  <div class="form-check form-switch">
                    <input class="form-check-input" type="checkbox" id="flexSwitchCheckDefault">
                    <label class="form-check-label" for="flexSwitchCheckDefault"></label>
                  </div>
                  <div class="input-group">
                    <input id="searchBar" type="search" class="form-control" placeholder="Search..." aria-label="Search"
                      aria-describedby="search-addon" />
                    <button id="searchButton" type="button" class="btn btn-outline-dark">
                      <i class="fa-solid fa-magnifying-glass"></i>
                    </button>
                  </div>
                </div>
              </li>
            </ul>
          </div>
        </div>
      </nav>
    </div>

    <section id="content-wrapper">
      {% block content-title %} {% endblock content-title %} {% block content %} {% endblock content %}
    </section>
  </div>
  {% endblock body %}
  <script src="https://cdn.jsdelivr.net/npm/bootstrap@5.2.3/dist/js/bootstrap.min.js"></script>
  <script src="https://unpkg.com/axios/dist/axios.min.js"></script>
  <script src="{% static 'home/js/retry.js' %}"></script>
  <script src="{% static 'home/js/base.js' %}"></script>
  {% block javascript %} {% endblock javascript %}
</body>
  <footer>
        <p>&copy; Powered by Dev Squad 2023 </p>
    </footer>
</html>